import { Query, QueryOptions } from './Query';
export declare function getCollectionName(typename: string): string;
declare type RequestClient = (path: string, method: string, variables: object) => Promise<any>;
export interface StoreOptions {
    request?: RequestClient;
    ssr?: boolean;
}
interface initialData {
    __queryCacheData?: Map<string, any>;
    __queryCache?: Map<string, any>;
}
export declare class MQStore {
    __queryCacheData: Map<any, any>;
    __queryCache: Map<any, any>;
    ssr: boolean;
    __promises: Map<any, any>;
    request: RequestClient;
    constructor(options: StoreOptions, data: initialData);
    getStore: () => this;
    merge(data: unknown): any;
    deflate(data: unknown): any;
    rawRequest(path: string, method: string, variables: any): Promise<any>;
    __cacheQuery(key: string, query: any): void;
    query<T>(path: string, method: string, variables?: any, options?: QueryOptions): Query<T>;
    getCollectionName: typeof getCollectionName;
    __pushPromise(promise: Promise<{}>, queryKey: string): void;
    __runInStoreContext<T>(fn: () => T): T;
    __cacheResponse(key: string, response: any): void;
}
export declare type StoreType = typeof MQStore;
export {};
